---
<%-
  require 'date'
  require 'set'

  default_partition = nil
  default_account = `sacctmgr -n -P list user $USER format=DefaultAccount`
  reservations = Set.new
  accounts = {}
  partitions = {}
  gpus = {}

  # get partitions and gres
  sinfo_lines=`sinfo -h -o "%P|%G|%b" | grep xfce`.split(/\n+/)
  for sinfo_line in sinfo_lines do
    partition, all_gres, features = sinfo_line.split('|')

    # check if this is default partition
    if partition.end_with?("*")
      partition = partition[0, partition.length()-1]
      default_partition = partition
    end

    # adding partition to partitions objects
    if !partitions.key?(partition)
        partitions[partition] = {
            'accounts' => Set.new,
            'reservations' => Set.new
        }
    end

    # collecting gpus from current partition
    gpus_list = Set.new
    for gres_item in all_gres.split(',')
      if gres_item != '(null)'
        gres_type, gres_name, gres_qty = gres_item.split(':')
        if gres_type == 'gpu'
          if !gpus.key?(gres_name)
              gpus[gres_name] = {
                  'partitions' => Set.new
              }
          end
          gpus[gres_name]['partitions'] << partition
        end
      end
    end
  end

  # get accounts and partitions associations
  sacctmgr_lines = `sacctmgr list -n -P associations user=$USER format=account%250,partition%250`.split(/\n+/)
  for sacctmgr_line in sacctmgr_lines
    account, partition = sacctmgr_line.split('|')
    if !accounts.key?(account)
      accounts[account] = {
          'reservations' => Set.new
      }
    end

    if partition == ''
        # this account has access to all partitions
        for partition in partitions.keys
          partitions[partition]['accounts'] << account
        end
    else
        if partitions.key?(partition)
          partitions[partition]['accounts'] << account
        end
    end
  end

  # get reservations
  scontrol_result = `scontrol show reservation -o`
  if !scontrol_result.include?("No reservations in the system")
    for reservation_line in scontrol_result.split(/\n+/)
      is_usable = false
      reservation = {}
      for reservation_part in reservation_line.split(' ')
        parts = reservation_part.split('=')
        if parts.length == 2 and parts[1] != '(null)'
            reservation[parts[0]] = parts[1]
        else
            reservation[parts[0]] = nil
        end
      end

      #reservation_start = DateTime.strptime(reservation['StartTime'], '%Y-%m-%dT%H:%M:%S')
      #if DateTime.now >= reservation_start
      #  # reservation is not started yet
      #  next
      #end

      if reservation['Accounts'] == nil
         # this reservation is available for all accounts
         reservation['Accounts'] = accounts.keys
         is_usable = true
      else
        reservation['Accounts'] = reservation['Accounts'].split(',')
        reservation_accounts = reservation['Accounts'].split(',')
        is_usable = reservation['Accounts'].intersection(accounts.keys).length > 0
      end

      if reservation['PartitionName'] != nil
        # we need to check if we have at least one account which has access to this partition
        for account in reservation['Accounts']
          if (!partitions.key?(reservation['PartitionName']) or !partitions[reservation['PartitionName']]['accounts'].include?(account))
            reservation['Accounts'].delete(account)
          end
        end
        if reservation['Accounts'].length == 0
          is_usable = false
        end
      end

      if is_usable
        reservations << reservation['ReservationName']
        for account in reservation['Accounts']
          accounts[account]['reservations'] << reservation['ReservationName']
        end
        if reservation['PartitionName'] != nil
            partitions[reservation['PartitionName']]['reservations'] << reservation['ReservationName']
        else
            for partition in partitions.keys
                partitions[partition]['reservations'] << reservation['ReservationName']
            end
        end
      end
    end
  end
%>

cluster: "igbmc"

attributes:

  desktop: "xfce"
  bc_vnc_idle: 0
  bc_vnc_resolution:
  required: true
  node_type: null

  bc_num_slots: 1
  bc_num_hours:
    max: 12
    value: 1

  slurm_reservation:
    widget: select
    required: false
    label: Reservation
    options:
      - ['No reservation', '']
      <% reservations.each do |reservation| %>
      - ['<%= reservation %>', '<%= reservation %>']
      <% end %>
    value: ''

  slurm_account:
    widget: select
    label: Account
    required: true
    options:
      <% accounts.keys.each do |account| %>
      - ['<%= account %>',
         '<%= account %>',
         data-reservations: <%= accounts[account]['reservations'].to_a.join(" ") %>,
        ]
      <% end %>
    value: <%= default_account %>

  slurm_partition:
    widget: select
    cacheable: false
    label: Partition
    required: true
    options:
      <% partitions.keys.each do |partition| %>
      - ['<%= partition %>',
         '<%= partition %>',
          data-accounts: "<%= partitions[partition]['accounts'].to_a.join(" ") %>",
          data-reservations: "<%= partitions[partition]['reservations'].to_a.join(" ") %>",
        ]
      <% end %>
    value: <%= default_partition %>

  slurm_gpu_count:
    widget: number_field
    cacheable: false
    label: Number of GPUs
    required: false
    value: 0

  slurm_gpu:
    widget: select
    cacheable: false
    label: GPUs
    required: fale
    options:
      - ['No GPU', '']
      <% gpus.keys.each do |gpu| %>
      - ['<%= gpu %>',
         '<%= gpu %>',
          data-partitions: "<%= gpus[gpu]['partitions'].to_a.join(" ") %>",
        ]
      <% end %>

  slurm_cpu:
    widget: number_field
    min: 1
    label: Number of CPUs
    required: true
    value: 1

  slurm_mem:
    widget: text_field
    value: 1G
    required: true
    label: Amount of memory
  
  threed:
    widget: check_box
    label: 3D visualization support (beta)
    help: While 3D visualization requires GPU to be present on the computing node, <strong>it is not mandatory to reserve GPUs for visualization tasks</strong>. GPUs reservations is only required for intensive GPU treatment for instance if you need to use CUDA enabled programs.
    value: no

form:
  - bc_vnc_idle
  - desktop
  - bc_vnc_resolution
  - slurm_reservation
  - slurm_account
  - slurm_partition
  # - threed
  - slurm_cpu
  - slurm_mem
  - slurm_gpu
  - slurm_gpu_count
  - bc_num_slots
  - bc_num_hours
  # - bc_email_on_started
